// This file was generated by gir (https://github.com/gtk-rs/gir)
// from
// from gir-files (https://github.com/gtk-rs/gir-files.git)
// DO NOT EDIT

use glib::{prelude::*, translate::*};
use std::fmt;

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "DzlDockRevealerTransitionType")]
pub enum DockRevealerTransitionType {
    #[doc(alias = "DZL_DOCK_REVEALER_TRANSITION_TYPE_NONE")]
    None,
    #[doc(alias = "DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT")]
    SlideRight,
    #[doc(alias = "DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT")]
    SlideLeft,
    #[doc(alias = "DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_UP")]
    SlideUp,
    #[doc(alias = "DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN")]
    SlideDown,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for DockRevealerTransitionType {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "DockRevealerTransitionType::{}",
            match *self {
                Self::None => "None",
                Self::SlideRight => "SlideRight",
                Self::SlideLeft => "SlideLeft",
                Self::SlideUp => "SlideUp",
                Self::SlideDown => "SlideDown",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for DockRevealerTransitionType {
    type GlibType = ffi::DzlDockRevealerTransitionType;

    #[inline]
    fn into_glib(self) -> ffi::DzlDockRevealerTransitionType {
        match self {
            Self::None => ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_NONE,
            Self::SlideRight => ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT,
            Self::SlideLeft => ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT,
            Self::SlideUp => ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_UP,
            Self::SlideDown => ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlDockRevealerTransitionType> for DockRevealerTransitionType {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlDockRevealerTransitionType) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_NONE => Self::None,
            ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_RIGHT => Self::SlideRight,
            ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_LEFT => Self::SlideLeft,
            ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_UP => Self::SlideUp,
            ffi::DZL_DOCK_REVEALER_TRANSITION_TYPE_SLIDE_DOWN => Self::SlideDown,
            value => Self::__Unknown(value),
        }
    }
}

impl StaticType for DockRevealerTransitionType {
    #[inline]
    #[doc(alias = "dzl_dock_revealer_transition_type_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_dock_revealer_transition_type_get_type()) }
    }
}

impl glib::HasParamSpec for DockRevealerTransitionType {
    type ParamSpec = glib::ParamSpecEnum;
    type SetValue = Self;
    type BuilderFn = fn(&str, Self) -> glib::ParamSpecEnumBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder_with_default
    }
}

impl glib::value::ValueType for DockRevealerTransitionType {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for DockRevealerTransitionType {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for DockRevealerTransitionType {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<DockRevealerTransitionType> for glib::Value {
    #[inline]
    fn from(v: DockRevealerTransitionType) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "DzlShortcutMatch")]
pub enum ShortcutMatch {
    #[doc(alias = "DZL_SHORTCUT_MATCH_NONE")]
    None,
    #[doc(alias = "DZL_SHORTCUT_MATCH_EQUAL")]
    Equal,
    #[doc(alias = "DZL_SHORTCUT_MATCH_PARTIAL")]
    Partial,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for ShortcutMatch {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "ShortcutMatch::{}",
            match *self {
                Self::None => "None",
                Self::Equal => "Equal",
                Self::Partial => "Partial",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for ShortcutMatch {
    type GlibType = ffi::DzlShortcutMatch;

    #[inline]
    fn into_glib(self) -> ffi::DzlShortcutMatch {
        match self {
            Self::None => ffi::DZL_SHORTCUT_MATCH_NONE,
            Self::Equal => ffi::DZL_SHORTCUT_MATCH_EQUAL,
            Self::Partial => ffi::DZL_SHORTCUT_MATCH_PARTIAL,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlShortcutMatch> for ShortcutMatch {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlShortcutMatch) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::DZL_SHORTCUT_MATCH_NONE => Self::None,
            ffi::DZL_SHORTCUT_MATCH_EQUAL => Self::Equal,
            ffi::DZL_SHORTCUT_MATCH_PARTIAL => Self::Partial,
            value => Self::__Unknown(value),
        }
    }
}

impl StaticType for ShortcutMatch {
    #[inline]
    #[doc(alias = "dzl_shortcut_match_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_shortcut_match_get_type()) }
    }
}

impl glib::HasParamSpec for ShortcutMatch {
    type ParamSpec = glib::ParamSpecEnum;
    type SetValue = Self;
    type BuilderFn = fn(&str, Self) -> glib::ParamSpecEnumBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder_with_default
    }
}

impl glib::value::ValueType for ShortcutMatch {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for ShortcutMatch {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for ShortcutMatch {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<ShortcutMatch> for glib::Value {
    #[inline]
    fn from(v: ShortcutMatch) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

#[cfg(feature = "v3_20")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_20")))]
#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "DzlShortcutType")]
pub enum ShortcutType {
    #[doc(alias = "DZL_SHORTCUT_ACCELERATOR")]
    Accelerator,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_PINCH")]
    GesturePinch,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_STRETCH")]
    GestureStretch,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_ROTATE_CLOCKWISE")]
    GestureRotateClockwise,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE")]
    GestureRotateCounterclockwise,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT")]
    GestureTwoFingerSwipeLeft,
    #[doc(alias = "DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT")]
    GestureTwoFingerSwipeRight,
    #[doc(alias = "DZL_SHORTCUT_GESTURE")]
    Gesture,
    #[doc(hidden)]
    __Unknown(i32),
}

#[cfg(feature = "v3_20")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_20")))]
impl fmt::Display for ShortcutType {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "ShortcutType::{}",
            match *self {
                Self::Accelerator => "Accelerator",
                Self::GesturePinch => "GesturePinch",
                Self::GestureStretch => "GestureStretch",
                Self::GestureRotateClockwise => "GestureRotateClockwise",
                Self::GestureRotateCounterclockwise => "GestureRotateCounterclockwise",
                Self::GestureTwoFingerSwipeLeft => "GestureTwoFingerSwipeLeft",
                Self::GestureTwoFingerSwipeRight => "GestureTwoFingerSwipeRight",
                Self::Gesture => "Gesture",
                _ => "Unknown",
            }
        )
    }
}

#[cfg(feature = "v3_20")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_20")))]
#[doc(hidden)]
impl IntoGlib for ShortcutType {
    type GlibType = ffi::DzlShortcutType;

    #[inline]
    fn into_glib(self) -> ffi::DzlShortcutType {
        match self {
            Self::Accelerator => ffi::DZL_SHORTCUT_ACCELERATOR,
            Self::GesturePinch => ffi::DZL_SHORTCUT_GESTURE_PINCH,
            Self::GestureStretch => ffi::DZL_SHORTCUT_GESTURE_STRETCH,
            Self::GestureRotateClockwise => ffi::DZL_SHORTCUT_GESTURE_ROTATE_CLOCKWISE,
            Self::GestureRotateCounterclockwise => {
                ffi::DZL_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE
            }
            Self::GestureTwoFingerSwipeLeft => ffi::DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT,
            Self::GestureTwoFingerSwipeRight => ffi::DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT,
            Self::Gesture => ffi::DZL_SHORTCUT_GESTURE,
            Self::__Unknown(value) => value,
        }
    }
}

#[cfg(feature = "v3_20")]
#[cfg_attr(docsrs, doc(cfg(feature = "v3_20")))]
#[doc(hidden)]
impl FromGlib<ffi::DzlShortcutType> for ShortcutType {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlShortcutType) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::DZL_SHORTCUT_ACCELERATOR => Self::Accelerator,
            ffi::DZL_SHORTCUT_GESTURE_PINCH => Self::GesturePinch,
            ffi::DZL_SHORTCUT_GESTURE_STRETCH => Self::GestureStretch,
            ffi::DZL_SHORTCUT_GESTURE_ROTATE_CLOCKWISE => Self::GestureRotateClockwise,
            ffi::DZL_SHORTCUT_GESTURE_ROTATE_COUNTERCLOCKWISE => {
                Self::GestureRotateCounterclockwise
            }
            ffi::DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_LEFT => Self::GestureTwoFingerSwipeLeft,
            ffi::DZL_SHORTCUT_GESTURE_TWO_FINGER_SWIPE_RIGHT => Self::GestureTwoFingerSwipeRight,
            ffi::DZL_SHORTCUT_GESTURE => Self::Gesture,
            value => Self::__Unknown(value),
        }
    }
}

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "DzlSliderPosition")]
pub enum SliderPosition {
    #[doc(alias = "DZL_SLIDER_NONE")]
    None,
    #[doc(alias = "DZL_SLIDER_TOP")]
    Top,
    #[doc(alias = "DZL_SLIDER_RIGHT")]
    Right,
    #[doc(alias = "DZL_SLIDER_BOTTOM")]
    Bottom,
    #[doc(alias = "DZL_SLIDER_LEFT")]
    Left,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for SliderPosition {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "SliderPosition::{}",
            match *self {
                Self::None => "None",
                Self::Top => "Top",
                Self::Right => "Right",
                Self::Bottom => "Bottom",
                Self::Left => "Left",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for SliderPosition {
    type GlibType = ffi::DzlSliderPosition;

    #[inline]
    fn into_glib(self) -> ffi::DzlSliderPosition {
        match self {
            Self::None => ffi::DZL_SLIDER_NONE,
            Self::Top => ffi::DZL_SLIDER_TOP,
            Self::Right => ffi::DZL_SLIDER_RIGHT,
            Self::Bottom => ffi::DZL_SLIDER_BOTTOM,
            Self::Left => ffi::DZL_SLIDER_LEFT,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlSliderPosition> for SliderPosition {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlSliderPosition) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::DZL_SLIDER_NONE => Self::None,
            ffi::DZL_SLIDER_TOP => Self::Top,
            ffi::DZL_SLIDER_RIGHT => Self::Right,
            ffi::DZL_SLIDER_BOTTOM => Self::Bottom,
            ffi::DZL_SLIDER_LEFT => Self::Left,
            value => Self::__Unknown(value),
        }
    }
}

impl StaticType for SliderPosition {
    #[inline]
    #[doc(alias = "dzl_slider_position_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_slider_position_get_type()) }
    }
}

impl glib::HasParamSpec for SliderPosition {
    type ParamSpec = glib::ParamSpecEnum;
    type SetValue = Self;
    type BuilderFn = fn(&str, Self) -> glib::ParamSpecEnumBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder_with_default
    }
}

impl glib::value::ValueType for SliderPosition {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for SliderPosition {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for SliderPosition {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<SliderPosition> for glib::Value {
    #[inline]
    fn from(v: SliderPosition) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}

#[derive(Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Clone, Copy)]
#[non_exhaustive]
#[doc(alias = "DzlTreeDropPosition")]
pub enum TreeDropPosition {
    #[doc(alias = "DZL_TREE_DROP_INTO")]
    Into,
    #[doc(alias = "DZL_TREE_DROP_BEFORE")]
    Before,
    #[doc(alias = "DZL_TREE_DROP_AFTER")]
    After,
    #[doc(hidden)]
    __Unknown(i32),
}

impl fmt::Display for TreeDropPosition {
    fn fmt(&self, f: &mut fmt::Formatter) -> fmt::Result {
        write!(
            f,
            "TreeDropPosition::{}",
            match *self {
                Self::Into => "Into",
                Self::Before => "Before",
                Self::After => "After",
                _ => "Unknown",
            }
        )
    }
}

#[doc(hidden)]
impl IntoGlib for TreeDropPosition {
    type GlibType = ffi::DzlTreeDropPosition;

    #[inline]
    fn into_glib(self) -> ffi::DzlTreeDropPosition {
        match self {
            Self::Into => ffi::DZL_TREE_DROP_INTO,
            Self::Before => ffi::DZL_TREE_DROP_BEFORE,
            Self::After => ffi::DZL_TREE_DROP_AFTER,
            Self::__Unknown(value) => value,
        }
    }
}

#[doc(hidden)]
impl FromGlib<ffi::DzlTreeDropPosition> for TreeDropPosition {
    #[inline]
    unsafe fn from_glib(value: ffi::DzlTreeDropPosition) -> Self {
        skip_assert_initialized!();

        match value {
            ffi::DZL_TREE_DROP_INTO => Self::Into,
            ffi::DZL_TREE_DROP_BEFORE => Self::Before,
            ffi::DZL_TREE_DROP_AFTER => Self::After,
            value => Self::__Unknown(value),
        }
    }
}

impl StaticType for TreeDropPosition {
    #[inline]
    #[doc(alias = "dzl_tree_drop_position_get_type")]
    fn static_type() -> glib::Type {
        unsafe { from_glib(ffi::dzl_tree_drop_position_get_type()) }
    }
}

impl glib::HasParamSpec for TreeDropPosition {
    type ParamSpec = glib::ParamSpecEnum;
    type SetValue = Self;
    type BuilderFn = fn(&str, Self) -> glib::ParamSpecEnumBuilder<Self>;

    fn param_spec_builder() -> Self::BuilderFn {
        Self::ParamSpec::builder_with_default
    }
}

impl glib::value::ValueType for TreeDropPosition {
    type Type = Self;
}

unsafe impl<'a> glib::value::FromValue<'a> for TreeDropPosition {
    type Checker = glib::value::GenericValueTypeChecker<Self>;

    #[inline]
    unsafe fn from_value(value: &'a glib::Value) -> Self {
        skip_assert_initialized!();
        from_glib(glib::gobject_ffi::g_value_get_enum(value.to_glib_none().0))
    }
}

impl ToValue for TreeDropPosition {
    #[inline]
    fn to_value(&self) -> glib::Value {
        let mut value = glib::Value::for_value_type::<Self>();
        unsafe {
            glib::gobject_ffi::g_value_set_enum(value.to_glib_none_mut().0, self.into_glib());
        }
        value
    }

    #[inline]
    fn value_type(&self) -> glib::Type {
        Self::static_type()
    }
}

impl From<TreeDropPosition> for glib::Value {
    #[inline]
    fn from(v: TreeDropPosition) -> Self {
        skip_assert_initialized!();
        ToValue::to_value(&v)
    }
}
